/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.polarion;

import it.eng.spago4q.extractors.bo.GenericItem;

import java.util.Iterator;

import com.polarion.alm.ws.client.types.tracker.WorkItem;

public class RequirementsUtil {

	private static final String NUM_CHANGE_REQUEST = "num_change_request";
	private static final String REQUIREMENT_CHILDREN = "requirement_children";
	
	private WorkItemUtil workItemUtil;
	
	public RequirementsUtil(WorkItemUtil workItemUtil) {
		this.workItemUtil = workItemUtil;
	}
	
	public void setAdditionalFields(WorkItem workItem, GenericItem item, String project) {
		setChildrenValue(workItem, item, project);
	}

	private void setChildrenValue(WorkItem workItem, GenericItem item, String project) {
    	int num_change_request = 0;
    	int requirement_children = 0;
    	
    	Iterator<WorkItem> childrenIterator = workItemUtil.getChildren(workItem, null, project).iterator();
		while (childrenIterator.hasNext()) {
			WorkItem child = childrenIterator.next();

			if (child.getType().getId().equals(PolarionWebServiceExtractor.TYPE_CHANGE_REQUEST))
				num_change_request++;

			else if (child.getType().getId().equals(PolarionWebServiceExtractor.TYPE_REQUIREMENT))
				requirement_children++;
		}
	    
    	item.setValue(NUM_CHANGE_REQUEST, String.valueOf(num_change_request));
    	item.setValue(REQUIREMENT_CHILDREN, String.valueOf(requirement_children));
		    
	}
	
}
