/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors.polarion;

import it.eng.spago4q.extractors.bo.GenericItem;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.polarion.alm.ws.client.types.tracker.WorkItem;

public class TestsUtil {

	/*
	 * TODO - Test da capire come derivare questi campi:
	 * 
	 * id_test_suite character varying, 
	 * id_test_level integer, 
	 * id_test_type integer, 
	 * not_planned character varying, 
	 * test_number integer, verif_phase
	 * character varying(5),
	 */

	public static final String ID_REQUIREMENT = "id_req";
	public static final String TEST_RESULT = "test_result";

	private WorkItemUtil workItemUtil;
	
	private Log log = LogFactory.getLog(TestsUtil.class);

	public TestsUtil(WorkItemUtil workItemUtil) {
		this.workItemUtil = workItemUtil;
	}

	public void setAdditionalFields(WorkItem workItem, GenericItem item,
			String project) {
		setRequirement(workItem, item, project);
		setTestResult(workItem, item, project);
	}

	private void setRequirement(WorkItem workItem, GenericItem item,
			String project) {
		List<WorkItem> testFather = workItemUtil.getFather(workItem,
				PolarionWebServiceExtractor.TYPE_REQUIREMENT, project);

		String idFather = null;
		if (testFather.size() > 0) {
			idFather = ((WorkItem) testFather.get(0)).getId();
		}
		if (idFather != null) {
			item.setValue(ID_REQUIREMENT, idFather);
		}

	}

	private void setTestResult(WorkItem workItem, GenericItem item,
			String project) {
		String result = null;
		String test_result = null;

		try {
			test_result = (String) item.getValue("status");
			if (test_result == null) {
				result = "space";

			} else if (test_result.equals("Chiuso")) {
				if (workItemUtil.getChildren(workItem,
						PolarionWebServiceExtractor.TYPE_BUG, project).size() == 0) {
					result = "OK";
				} else {
					result = "KO";
				}
			} else if (test_result.equals("Esecuzione_Test")) {
				if (workItemUtil.getChildren(workItem,
						PolarionWebServiceExtractor.TYPE_BUG, project).size() > 0) {
					result = "KO";
				}
			} else {
				result = "space";
			}
		} catch (Exception e) {
			log.error("Unable to map: " + TEST_RESULT);
			result = "space";
		}
		if (result != null) {
			item.setValue(TEST_RESULT, result);
		}
	}
}
